﻿#target photoshop

// Hoodie Resize script for Merch By Amazon
// This script will resize any 4500x5400px image to the 4500x4050px image required for Hoodies
// It will also scale down the image without causing any distortion 
// Made by Greg Hesp for Merch Informer

var destFolder,
    sourceFolder,
    files,
    fileType,
    sourceDoc;
    
var startRulerUnits = app.preferences.rulerUnits;
var maintainAspectRatio  = true;

app.preferences.rulerUnits = Units.PIXELS;

sourceFolder = Folder.selectDialog('Select the folder that contains the .png files to convert to hoodies');

if(sourceFolder != null) {
  files = new Array();
  fileType = "*.png";
  files = sourceFolder.getFiles(fileType);
  
  if(files.length > 0) {
    destFolder = Folder.selectDialog('Select the folder where you want to save the hoodie files');

    for(i=0; i<files.length; i++) {
      sourceDoc = app.open(files[i], undefined, true);
      var docRef = sourceDoc;
      
     var fileNameNoExtension = docRef.name;
      fileNameNoExtension = fileNameNoExtension.split( "." );
		if ( fileNameNoExtension.length > 1 ) {
			fileNameNoExtension.length--;
		} 
	fileNameNoExtension = fileNameNoExtension.join(".");
      
      var suffix = "-Hoodie";
      var saveName = new File(decodeURI(destFolder)+'/'+fileNameNoExtension+suffix+'.png');

      with(docRef){
        var bounds = activeDocument.activeLayer.bounds;
        var height = bounds[3].value - bounds[1].value;
           
        var newSize = (100 / height) * 4050;
        app.activeDocument.resizeCanvas (4500, 4050);
        
        activeDocument.activeLayer.resize(newSize, newSize, AnchorPosition.MIDDLECENTER);
        
     var doc = activeDocument;
	var layer = doc.activeLayer;
	var bounds = layer.bounds;

	var docWidth = Number(doc.width);
	var docHeight = Number(doc.height);


	var layerWidth = Number(bounds[2] - bounds[0]);
	var layerHeight = Number(bounds[3] - bounds[1]);

	var dX = (docWidth - layerWidth) / 2 - Number(bounds[0]);
	var dY = (docHeight - layerHeight) / 2 - Number(bounds[1]);


	layer.translate(dX, dY);
       
        sfwPNG24(saveName);
        docRef.close(SaveOptions.DONOTSAVECHANGES);
      }

    }

  }
}
  app.preferences.rulerUnits = startRulerUnits;

function sfwPNG24(saveFile){
    var pngOpts = new PNGSaveOptions;
    pngOpts.compression = 9;
    pngOpts.interlaced = false;
    activeDocument.saveAs(saveFile, pngOpts, true, Extension.LOWERCASE);

}

